// BufferInputStream
// For reading data from a byte array instead of an actual stream. Grabs the
// gets method from LineInputStream
import java.io.*;

public class BufferInputStream extends LineInputStream
{
	byte array[];
	int count;
	int markpos = 0;

	// construct a stream for reading from the given array
	BufferInputStream(byte a[])
	{
	array = a;
	count = 0;
	}

	public int read()
	{
	if (count == array.length)
		return -1;
	return array[count++];
	}

	public int read(byte b[])
	{
	return read(b, 0, b.length);
	}

	public int read(byte b[], int off, int len)
	{
	if (count+len > array.length)
		return -1;
	System.arraycopy(array, count, b, off, len);
	count += len;
	return len;
	}

	public long skip(long n)
	{
	if (count+n > array.length)
		n = array.length-count;
	count += n;
	return n;
	}

	public int available()
	{
	return array.length - count;
	}

	public void close() { }

	public synchronized void mark(int readlimit)
	{
	markpos = count;
	}

	public synchronized void reset()
	{
	count = markpos;
	}

	public boolean markSupported()
	{
	return true;
	}
}

