// DeleteUser
// A command line program for removing a JFS user
import java.io.*;
import java.util.Vector;

public class DeleteUser
{
	public static void main(String argv[])
	{
	if (argv.length != 2) {
		System.err.println("usage: DeleteUser <JFS root> <username>");
		System.exit(1);
		}
	FileSystem.init(argv[0]);
	JFSserver.loadcache();

	// Read in users
	BufferInputStream ibuf = null;
	try { ibuf = new BufferInputStream(
		   FileSystem.getfile("/etc/users", 0, -1, -1)); }
	catch(BadPathException e) {
		System.err.println("Could not open /etc/users");
		System.exit(1);
		}
	Vector users = new Vector();
	try { while(true) users.addElement(new JFSuser(ibuf.gets())); }
	catch(IOException e) { }

	// Find the user
	JFSuser vic = null;
	for(int i=0; i<users.size(); i++) {
		JFSuser u = (JFSuser)users.elementAt(i);
		if (u.name.equals(argv[1]))
			vic = u;
		}
	if (vic == null) {
		System.err.println("Could not find user "+argv[1]);
		System.exit(1);
		}

	// Delete and write out
	users.removeElement(vic);
	BufferOutputStream obuf = new BufferOutputStream();
	for(int i=0; i<users.size(); i++)
		obuf.puts(((JFSuser)users.elementAt(i)).output());
	try { FileSystem.putfile("/etc/users", 0, obuf.getarray(),
			       "root", "text/plain"); }
	catch(BadPathException e) {
		System.err.println("Failed to write /etc/users");
		System.exit(1);
		}

	// Remove home directory
	if (vic.home.length() > 1) {
		try { FileSystem.delete(vic.home, 0); }
		catch(BadPathException e) { }
		}
	}
}

