// ImageSplitter
// A class for splitting one image into many equal-sized images.
import java.awt.*;
import java.awt.image.*;

public class ImageSplitter
{
	Component parent;

	ImageSplitter(Component p)
	{
	parent = p;
	}

	// split
	// Convert an image consisting of x by y equal sized sub-images
	// into an array of images.
	Image [][] split(Image in, int x, int y)
	{
	MediaTracker mt = new MediaTracker(parent);
	mt.addImage(in, 0);
	try { mt.waitForAll(); }
	catch(Exception e) { }
	Image out[][] = new Image[x][y];
	int tw = in.getWidth(parent), th = in.getHeight(parent);
	int w = tw/x, h = th/y;
	Toolkit tk = Toolkit.getDefaultToolkit();
	for(int i=0; i<x; i++) {
		for(int j=0; j<y; j++) {
			ImageFilter crop = new CropImageFilter(i*w, j*h, w, h);
			out[i][j] = tk.createImage(
				     new FilteredImageSource(in.getSource(),
							     crop));
			}
		}
	return out;
	}
}

