// LineOutputStream
// A stream with the puts() method. Can be used either for inheriting puts()
// into your own output stream, or for adding puts to some output stream
import java.io.OutputStream;
import java.io.IOException;

public class LineOutputStream
{
	byte buf[] = new byte[100];
	OutputStream out;

	LineOutputStream(OutputStream o)
		{ out = o; }

	LineOutputStream()
		{ }

	public void close() throws IOException
		{ out.close(); }
	public void flush() throws IOException
		{ out.flush(); }
	public void write(byte b[], int o, int l) throws IOException
		{ out.write(b, o, l); }
	public void write(byte b[]) throws IOException
		{ out.write(b); }
	public void write(int b) throws IOException
		{ out.write(b); }

	// puts
	// Output a line, plus a \n
	void puts(String str)
	{
	int l = str.length();
	if (l+1 > buf.length) buf = new byte[l+1];
	str.getBytes(0, l, buf, 0);
	buf[l] = (byte)'\n';
	try { write(buf,0,l+1); }
	catch(IOException e) { }
	}

	// print
	// Output a string
	void print(String str)
	{
	int l = str.length();
	str.getBytes(0, l, buf, 0);
	try { write(buf,0,l); }
	catch(IOException e) { }
	}

	// print
	// Output a single character
	void print(char c)
	{
	try { write((byte)c); }
	catch(IOException e) { }
	}

	// print
	// Output an integer
	void print(int i) { print(String.valueOf(i)); }

	// print
	// Output a floating-point
	void print(float f) { print(String.valueOf(f)); }
}

