import java.util.StringTokenizer;
import java.util.Vector;

public class MimeType
{
	String maj, min;
	Vector pname = new Vector(), pval = new Vector();

	MimeType(String s)
	{
	StringTokenizer tok = new StringTokenizer(s.trim(),"/;");
	if (tok.countTokens() < 2) return;
	maj = tok.nextToken();
	min = tok.nextToken();
	// Parse any extra foo=bar; baz=quux parts
	while(tok.hasMoreTokens()) {
		String param = tok.nextToken().trim();
		int eq = param.indexOf('=');
		if (eq < 0)
			continue;
		String name = param.substring(0, eq);
		String val = param.substring(eq+1);
		if (val.charAt(0) == '\"')
			val = val.substring(1, val.length()-1);
		pname.addElement(name);
		pval.addElement(val);
		}
	}

	MimeType(String ma, String mi)
	{
	maj = ma;
	min = mi;
	}

	// valid
	// Was this mime type properly specified?
	boolean valid()
	{
	return maj!=null && min!=null;
	}

	// exact
	// returns false if this mime type contains *'s
	boolean exact()
	{
	return valid() && maj.indexOf('*')<0 && min.indexOf('*')<0;
	}

	// equals
	// Does this mime type match another?
	boolean equals(MimeType t)
	{
	if ((t.maj.equalsIgnoreCase(maj)||t.maj.equals("*")||maj.equals("*")) &&
	    (t.min.equalsIgnoreCase(min)||t.min.equals("*")||min.equals("*")))
		return true;
	return false;
	}

	public String toString()
	{
	return maj+"/"+min;
	}

	// find
	// Find the value of some extra parameter
	String find(String s)
	{
	for(int i=0; i<pname.size(); i++)
		if (((String)pname.elementAt(i)).equals(s))
			return (String)pval.elementAt(i);
	return null;
	}
}

